-- vertex
#version 460 core

layout(location = 0) in vec4 pos;
layout(location = 1) in vec2 texCoords;

uniform mat4 mv;
uniform mat4 proj;

flat out uint drawID;       // integer varying (out) must be flat
out vec2 tex;

void main(void)
{
	drawID      = uint ( gl_DrawID );
	tex         = texCoords;
	gl_Position = proj * mv * vec4 ( pos.xyz, 1.0 );
}

-- fragment
#version 460 core

flat in  uint drawID;
in  vec2 tex;

layout ( location = 0 ) out uint triangle;		// triangle id
layout ( location = 1 ) out vec4 uv;

void main ()
{
	triangle = 1 + gl_PrimitiveID + (drawID << 16);     // 0 mean empty
	uv       = vec4 ( dFdx ( tex ), dFdy ( tex ) );
}