-- vertex
#version 460 core

layout(location = 0) in vec4 pos;

uniform mat4 mv;
uniform mat4 proj;

flat out uint drawID;       // integer varying (out) must be flat

void main(void)
{
	drawID      = uint ( gl_DrawID );
	gl_Position = proj * mv * vec4 ( pos.xyz, 1.0 );
}

-- fragment
#version 460 core

flat in  uint drawID;

layout ( location = 0 ) out uint triangle;		// triangle id

void main ()
{
	triangle = 1 + gl_PrimitiveID + (drawID << 16);     // 0 mean empty
}